#include <iostream>
#include <string>
#include <boost/xpressive/xpressive.hpp>
#include <boost/xpressive/traits/null_regex_traits.hpp>
using namespace std;
using namespace boost::xpressive;

int main()
{
    null_regex_traits<int> nul;
    basic_regex<int*> onedigs = imbue(nul)( +range(1, 9) );

    int array[] = { 123, 4, 5, 67, -8, 9 };
    regex_iterator<int*> it( &array[0], &array[6], onedigs );
    regex_iterator<int*> end;
    for( ; it!=end; ++it )
        cout << "[" << it->position() << ","
                    << it->position()+it->length() << ")" << endl;
}
