#include <iostream>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/io.hpp>
using namespace std;
using namespace boost::numeric;
using namespace boost::numeric::ublas;

int main()
{
    // xNg (1, 2, 3)
    ublas::vector<int> v( 3 );
    for( int i=0; i!=3; ++i )
        v( i ) = i+1;

    // s (1 2 3)
    // @@ (2 4 6)
    // @@ (3 6 9)
    matrix<int> a( 3, 3 );
    for( int i=0; i!=3; ++i )
        for( int j=0; j!=3; ++j )
            a( i, j ) = (i+1)*(j+1);

    // a*v\
    cout << prod(a,v) << endl;

    return 0;
}
