#include <cctype>
#include <boost/iostreams/filtering_stream.hpp>
#include <boost/iostreams/concepts.hpp>
#include <boost/iostreams/operations.hpp>
using namespace std;
using namespace boost::iostreams;

class upper_filter : public output_filter
{
public:
    template<typename Sink>
      bool put( Sink& snk, int c )
      {
          return boost::iostreams::put(snk, toupper(c));
      }
};

#include <iostream>
#include <fstream>

int main()
{
    {
        // Wo͂ł
        filtering_ostream s;
        s.push(upper_filter());
        s.push(cout);
        s << "Hello World" << endl;
    }
    {
        // t@Co͂ł
        ofstream ofs("data.txt");
        filtering_ostream s;
        s.push(upper_filter());
        s.push(ofs);
        s << "Hello World" << endl;
    }
}
