#include <iostream>
#include <ctime>
#include <boost/random.hpp>
using namespace std;
using namespace boost;

// TCRNX
//   Lagged Fibonacci@gāA1`6̐_ɕԂ
class Dice
{
public:
    Dice( uint32_t seed )
      : rand( lagged_fibonacci607(seed), uniform_int<>(1,6) ) {}
    int operator()() { return rand(); }

private:
    variate_generator< lagged_fibonacci607, uniform_int<> > rand;
};

int main()
{
    // ݎɁATCR
    uint32_t seed = static_cast<uint32_t>( time(0) );
    Dice xiA( seed   );
    Dice xiB( seed+1 );

    while( true )
    {
        // TCRU == _Ȓlo
        const int    a = xiA();
        const int    b = xiB();
        const bool cho = ((a+b)%2 == 0);

        // vC[ɖ₢
        cout << ">>> (0)(1)H ";
        int guess=-1; cin >> guess;
        if( guess!=0 && guess!=1 ) break;

        // ʂ̕\
        cout << a << " " << b << "  "
             << (cho?"":"")  << "B"
             << (cho ^ (guess==1) ? "I" : "OI")
             << endl;
    }
    return 0;
}
