#include <iostream>
#include <string>
#include <boost/variant.hpp>
using namespace std;
using namespace boost;

// uQ{vvisitor
struct do_double : static_visitor<>
{
    template<typename T>
      void operator()( T& t ) const { t = t + t; }
};

int main()
{
    variant<int,double,string> v;

    v = -2;
    apply_visitor( do_double(), v );
    cout << v << endl;

    v = 3.14;
    apply_visitor( do_double(), v );
    cout << v << endl;

    v = "hoge";
    apply_visitor( do_double(), v );
    cout << v << endl;

    return 0;
}
