#include <iostream>
#include <string>
#include <boost/spirit.hpp>
using namespace std;
using namespace boost::spirit;

// @"MyGrammar"̒`
struct MyGrammar : grammar<MyGrammar>
{
    template<typename ScannerT>
      struct definition
      {
          typedef rule<ScannerT> rule_t;
          rule_t r;

          definition( const MyGrammar& )
          {
              r = ch_p('a') >> *ch_p('b') >> ch_p('c');
          }

          const rule_t& start() const { return r; }
      };
};

int main()
{
    // @MyGrammarɊÂ\͊쐬
    MyGrammar parser;

    // 1sǂݍ
    string line;
    while( cout<<"# ", getline(cin, line) )
    {
        // 1s\
        parse_info<string::const_iterator> info =
            parse( line.begin(), line.end(), parser );
        // ͑ŜparsełA"OK"ƕ\
        cout << (info.full ? "OK" : "fail") << endl;
    }   // ȉEOF͂܂ŌJԂ
    return 0;
}
