#include <iostream>
#include <string>
#include <boost/lexical_cast.hpp>
#include <boost/fusion/sequence.hpp>
#include <boost/fusion/algorithm.hpp>
#include <boost/type_traits.hpp>
#include <boost/mpl/lambda.hpp>
using namespace std;
using namespace boost;
using namespace boost::fusion;

// ɒ
struct ToString
{
	template<typename T>
	string operator()( const T& t ) const
	{
		return lexical_cast<string>(t);
	}

    template<typename T>
    struct result
    {
        typedef string type;
    };
};

int main()
{
    using boost::mpl::_1;

    // int,string,float̃^v
    typedef fusion::vector<int,string,float> MyTuple;
    MyTuple t(123, "ɂ", 4.56);

    // {^݂̂c^v
    typedef fusion::filter_view<const MyTuple, is_fundamental<_1> > MyTuple2;
    MyTuple2 t2 = filter_if< is_fundamental<_1> >(t);

    // Sstring^v
    typedef fusion::transform_view<const MyTuple2, ToString> MyTuple3;
    MyTuple3 t3 = transform(t2, ToString());

    // \
    cout << t3 << endl;
}
