#include <iostream>
#include <fstream>
#include <string>
#include <boost/wave.hpp>
#include <boost/wave/cpplexer/cpp_lex_token.hpp>
#include <boost/wave/cpplexer/cpp_lex_iterator.hpp>
using namespace std;
using namespace boost::wave;

int main(int argc, const char* argv[])
{
    try {
        // t@C argv[1] ̓eS text ɓǂݍ
        ifstream fin( argv[1] );
        string  text( istreambuf_iterator<char>(fin.rdbuf()),
                      istreambuf_iterator<char>() );

        // vvZbTp
        typedef context<string::iterator,
                        cpplexer::lex_iterator< cpplexer::lex_token<> > > context_t;
        context_t ctx( text.begin(), text.end(), argv[1] );

        // IvV}Nݒ
        ctx.set_language(language_support(support_cpp | support_option_variadics));
        ctx.add_macro_definition("_WIN32");
        ctx.add_macro_definition("_MSC_VER=1400");
        ctx.add_sysinclude_path("C:\\Develop\\Boost");
        ctx.add_sysinclude_path("C:\\Develop\\vs2005\\VC\\INCLUDE");

        // Ce[^擾
        context_t::iterator_type it  = ctx.begin();
        context_t::iterator_type end = ctx.end();

        // g[NԂɕ\
        for(; it!=end; ++it)
            cout << it->get_position() << " :: " << it->get_value() << endl;
    } catch( cpp_exception& e ) {
        // G[
        cerr << e.file_name() << "(" << e.line_no() << "):"
             << e.description() << endl;
    }
}
