#include <iostream>
#include <boost/iostreams/filtering_stream.hpp>
#include <boost/iostreams/copy.hpp>
#include <boost/iostreams/tee.hpp>
#include <boost/iostreams/filter/gzip.hpp>
#include <boost/iostreams/device/file.hpp>
using namespace std;
using namespace boost::iostreams;

int main( int argc, const char* argv[] )
{
    if( argc < 2 )
        cerr << argv[0] << " [*.gz] [logfile]" << endl;
    else
    {
        // ́Bt@CǂݍgzipWJ
        filtering_istream src;
        src.push( gzip_decompressor() );
        src.push( file_source(argv[1], std::ios::binary) );

        // óBt@Cɉŏ݂AWo͂ɕ\
        filtering_ostream sink;
        if( argc>=3 )
            sink.push( tee(file_sink(argv[2])) );
        sink.push( cout );

        // ͂o͂ցII
        copy( src, sink );
    }
}
