#include <iostream>
#include <cctype>   // toupper
#include <boost/iostreams/stream.hpp>
#include <boost/iostreams/concepts.hpp>
using namespace std;
using namespace boost::iostreams;

class upper_cout : public sink
{
public:
    std::streamsize write( const char* s, std::streamsize n )
    {
        for(int i=0; i<n; ++i)
            cout.put( toupper(s[i]) );
        return n;
    }
};

int main()
{
    upper_cout uc;
    stream<upper_cout> s(uc);

    s << "Hello World" << endl;
}
