#include <iostream>
#include <string>
#include <vector>
#include <boost/range.hpp>
using namespace std;
using namespace boost;

template<typename Range, typename T>
  bool has( const Range& r, const T& value )
  {
    typename range_const_iterator<Range>::type i = begin(r), e = end(r);
    for(; i!=e; ++i)
      if( *i == value )
        return true;
    return false;
  }

int main()
{
    // gݍ݂̔zł
    int arr[] = {1,2,3};
    cout << has(arr, 1) << endl;

    // Rei(vector)ł
    vector<int> vs; vs.push_back(1); vs.push_back(2); vs.push_back(3);
    cout << has(vs, 2) << endl;

    // Rei(string)ł
    string s = "ABC";
    cout << has(s, 'D') << endl;

    // Reïꕔł
    cout << has(make_iterator_range(vs.begin(), vs.begin()+1), 2 ) << endl;
}
