#include <iostream>
#include <string>
#include <boost/spirit.hpp>
using namespace std;
using namespace boost::spirit;

struct VariableNameList : grammar<VariableNameList>
{
    template<typename ScannerT>
      struct definition
      {
          rule<ScannerT> name, name_list;
          definition( const VariableNameList& )
          {
              // ϐ̒`B擪̓At@xbg'_'ŁA
              // ɃAt@xbg'_'̗񂪑
              name = lexeme_d[ (alpha_p|'_') >> *(alpha_p|'_'|digit_p) ];
              // ϐ̃R}؂胊Xg
              name_list = name % ',';
          }
          const rule<ScannerT>& start() const { return name_list; }
      };
};

int main()
{
    for( string line; cout<<"# ", getline(cin, line); )
        if( parse(line.c_str(), VariableNameList(), space_p).full )
             cout << "OK" << endl;
        else cout << "fail" << endl;
    return 0;
}
