#include <iostream>
#include <string>
#include <boost/fusion/sequence.hpp>
#include <boost/fusion/algorithm.hpp>
using namespace std;
using namespace boost::fusion;

// uQ{v
struct Double
{
    template<typename T>
    void operator()( T& x ) const
    {
        x = x+x;
    }
};

int main()
{
    boost::fusion::vector<int,string,float> t( 123, "ɂ", 4.56 );
    for_each(t, Double());

    cout << at_c<0>(t) << at_c<1>(t) << at_c<2>(t) << endl;
}
