#include <iostream>
#include <typeinfo>
#include <boost/mpl/sizeof.hpp>
#include <boost/mpl/list.hpp>
#include <boost/mpl/sort.hpp>
#include <boost/mpl/for_each.hpp>
using namespace boost::mpl;

// ^̃Xg
typedef list<int, char, double, short, void*> TypeList;

// sizeof̏Ƀ\[g
typedef sort< TypeList, less< sizeof_<_1>, sizeof_<_2> > >::type SortedTL;

struct print_type {
  template<typename T>
    void operator()( const T& ) const
      { std::cout << typeid(T).name() << std::endl; }
};

int main()
{
    // ^Xg̊e^print_type֐IuWFNgs
    for_each< SortedTL >( print_type() );
    return 0;
}
