#include <iostream>
#include <boost/mpl/bool.hpp>
#include <boost/mpl/int.hpp>
#include <boost/mpl/arithmetic.hpp>
#include <boost/mpl/bitwise.hpp>
using namespace boost::mpl;

int main()
{
    typedef plus< int_<1>, int_<2> >::type one_plus_two;
    std::cout << one_plus_two::value << std::endl;

    typedef bitxor_< bool_<true>, bool_<false> >::type xor_t_f;
    std::cout << xor_t_f::value << std::endl;
    return 0;
}
